
var LikeButton = {
init: function() {
         this.idData = []; 
		  chrome.browserAction.setBadgeBackgroundColor({color:[59, 89, 152, 255]});
	  },

getGraphData: function(tab) {

				  if(!tab) {
					  return;
				  }

				  var c = this;
				  var takeurl = tab.url;
				  var protocol = this.get_prot_from_url(takeurl);
				  var resp = null;
				  var tid = this.genIdData(tab); 

				  if(this.checkOptions(tab)) {
					  return;
				  } 

				  var url = protocol + "://api.facebook.com/restserver.php?format=json&method=links.getStats&urls=" + encodeURIComponent(takeurl) + "&app_id=131265456953446";
				  
				  var ajax = new XMLHttpRequest();
				  ajax.open("GET", url, true);
				  ajax.onreadystatechange = function() {
					  if (ajax.readyState == 4) {
						  resp = JSON.parse(ajax.responseText);
						  if ( typeof resp[0].total_count != "undefined" && resp[0].total_count != "") { 
							  c.badgenr(resp[0].total_count,tab);
						  }
					  }
				  }
				  ajax.send();
			  },

checkOptions: function(tab) {
				  var domain = this.get_domain_from_url(tab.url);
				  var protocol = this.get_prot_from_url(tab.url);
				  var https_traffic = localStorage["like_button_https_traffic"];

				  if(https_traffic == "true" && protocol == "https") {
					  chrome.browserAction.setIcon({tabId:tab.id, path:"images/like_thumb_grey.png"});
					  return 1;
				  }

				  if(domain.indexOf("facebook.com")>=0) {
					  chrome.browserAction.setIcon({tabId:tab.id, path:"images/like_thumb_grey.png"});
					  return 1;
				  }

				  if (protocol != "http" && protocol != "https") {
					  chrome.browserAction.setIcon({tabId:tab.id, path:"images/like_thumb_grey.png"});
					  return 1;
				  }

				  var blacklisted_domains = localStorage["like_button_excluded_domains"];
				  if(blacklisted_domains != undefined && blacklisted_domains.length >= 4) {
					  var blck = blacklisted_domains.replace(/ /g,'');
					  var blck_array = blck.split(",");

					  for(var i = 0; i < blck_array.length; i++) {
						  if(domain.indexOf(blck_array[i])>=0) {
							  chrome.browserAction.setIcon({tabId:tab.id, path:"images/like_thumb_grey.png"});
							  return 1;
						  }
					  }
				  }
				  chrome.browserAction.setIcon({tabId:tab.id, path:"images/like_thumb.png"});
				  return 0;
			  },

genIdData: function(tab) {
			   if (!this.idData[tab.id]) {
				   this.idData[tab.id] = Math.floor(Math.random()*99999999);
			   }
			   return this.idData[tab.id];
		   },

badge: function(text,tab) {
		   var d = new Object();
		   d.text = text;
		   d.tabId = tab.id;
		   chrome.browserAction.setBadgeText(d);
	   },

badgenr: function(text,tab) {
			 inttext = this.int2roundKMB(text);
			 this.tooltip(this.formatNumber(text) + " people like this page.", tab);
			 this.badge(inttext, tab)
		 },


truncNb: function (Nb, ind) {
			 var _nb = Nb * (Math.pow(10,ind));
			 _nb = Math.floor(_nb);
			 _nb = _nb / (Math.pow(10,ind));
			 return Math.floor(_nb);
		 },

formatNumber: function (nStr) {
				  nStr += '';
				  x = nStr.split('.');
				  x1 = x[0];
				  x2 = x.length > 1 ? '.' + x[1] : '';
				  var rgx = /(\d+)(\d{3})/;
				  while (rgx.test(x1)) {
					  x1 = x1.replace(rgx, '$1' + ',' + '$2');
				  }
				  return x1 + x2;
			  },

int2roundKMB: function (val) {
				  var _str = "";
				  if (val >= 1e9) { 
					  _str = this.truncNb((val/1e9), 1) + 'B';
				  } else if (val >= 1e6) { 
					  _str = this.truncNb((val/1e6), 1) + 'M';
				  } else if (val >= 1e3) {
					  _str = this.truncNb((val/1e3), 1) + 'K';
				  } else { 
					  _str = parseInt(val);
				  }
				  return ""+_str;
			  },

tooltip: function(text,tab) {
			 var d = new Object();
			 d.title = text;
			 d.tabId = tab.id;
			 chrome.browserAction.setTitle(d);
		 },

get_domain_from_url: function(url) {
						 return url.match(/:\/\/(.[^/]+)/)[1]
					 },

get_prot_from_url: function(url) {
					   return url.match(/^(.[^:]+):/)[1]
				   },

};

LikeButton.init();

chrome.tabs.onUpdated.addListener(function(tabId, change, ttab) {
		if ( change.status == "loading" ) {
		chrome.tabs.getSelected(null, function(tab) {
			LikeButton.getGraphData(tab);
			});
		}
		});

